var results = [
    { id: '1', date: '05-02-2019', name: 'jQuery', address: 'Your Address Here', state: 'Alabama', city: 'Birmingham' },
    { id: '2', date: '05-03-2019', name: 'Script', address: 'Your Address Here', state: 'Alaska', city: 'Anchorage' },
    { id: '3', date: '05-04-2019', name: 'CSS', address: 'Your Address Here', state: 'American Samoa', city: 'Tafuna' },
    { id: '4', date: '05-05-2019', name: 'HTML', address: 'Your Address Here', state: 'Arizona', city: 'Phoenix' },
];

// 基础表格
function makeBasicTable() {
    var option = {
        tableClass: 'cgridTable',
        head: [
            {
                'data-field': 'id',
                'display': false
            },
            {
                'data-field': 'date',
                'name': 'Date'
            },
            {
                'data-field': 'name',
                'name': 'Name'
            },
            {
                'data-field': 'address',
                'name': 'Address'
            }
        ]
    };
    var ctable = cgrid.instance("basicTable", option);
    ctable.genTable(results);
}

// 固定表头
function fixedHeaderTable() {
    var option = {
        tableClass: 'cgridTable',
        head: [
            {
                'data-field': 'id',
                'display': false
            },
            {
                'data-field': 'date',
                'name': 'Date'
            },
            {
                'data-field': 'name',
                'name': 'Name'
            },
            {
                'data-field': 'address',
                'name': 'Address'
            }
        ],
        titleFixed: true,
    };
    var ctable = cgrid.instance("fixedHeaderTable", option);
    ctable.genTable(results.concat(results));
}

// 固定列
function fixedColumnTable() {
    var option = {
        tableClass: 'cgridTable cgridTable_fixedColumn',
        head: [
            {
                'data-field': 'id',
                'display': false
            },
            {
                'data-field': 'date',
                'name': 'Date',
                'fixed': true
            },
            {
                'data-field': 'name',
                'name': 'Name',
                'fixed': true
            },
            {
                'data-field': 'state',
                'name': 'State'
            },
            {
                'data-field': 'city',
                'name': 'City'
            },
            {
                'data-field': 'address',
                'name': 'Address'
            }
        ],
        titleFixed: true,
    };
    var ctable = cgrid.instance("fixedColumnTable", option);
    ctable.genTable(results);
}

// 固定列和表头
function fixedColHeadTable() {
    var option = {
        tableClass: 'cgridTable cgridTable_fixedColumn',
        head: [
            {
                'data-field': 'id',
                'display': false
            },
            {
                'data-field': 'date',
                'name': 'Date',
                'fixed': true
            },
            {
                'data-field': 'name',
                'name': 'Name',
                'fixed': true
            },
            {
                'data-field': 'state',
                'name': 'State'
            },
            {
                'data-field': 'city',
                'name': 'City'
            },
            {
                'data-field': 'address',
                'name': 'Address'
            }
        ],
        titleFixed: true,
    };
    var ctable = cgrid.instance("fixedColHeadTable", option);
    ctable.genTable(results.concat(results));
}

// 多级表头
function groupHeaderTable() {
    var option = {
        tableClass: 'cgridTable',
        head: [
            {
                'data-field': 'id',
                'display': false
            },
            {
                'data-field': 'date',
                'name': 'Date'
            },
            {
                'data-field': 'delivery',
                'name': 'Delivery',
                'children': [
                    {
                        'data-field': 'name',
                        'name': 'Name'
                    },
                    {
                        'data-field': 'addr',
                        'name': 'Address',
                        'children': [
                            {
                                'data-field': 'state',
                                'name': 'State'
                            },
                            {
                                'data-field': 'city',
                                'name': 'City'
                            },
                            {
                                'data-field': 'address',
                                'name': 'Address'
                            }
                        ]
                    },
                ]
            }
        ]
    };
    var ctable = cgrid.instance("groupHeaderTable", option);
    ctable.genTable(results);
}

// 单选
var oneRowSelTable;
function oneRowSelTable() {
    var option = {
        withCheckBox: true,
        disableMutiSel: true,
        tableClass: 'cgridTable',
        head: [
            {
                'data-field': 'id',
                'display': false
            },
            {
                'data-field': 'date',
                'name': 'Date'
            },
            {
                'data-field': 'name',
                'name': 'Name'
            },
            {
                'data-field': 'address',
                'name': 'Address'
            }
        ]
    };
    oneRowSelTable = cgrid.instance("oneRowSelTable", option);
    oneRowSelTable.genTable(results);
}

function oneRowClick() {
    var selectedRow = oneRowSelTable.getChecked();
    if (selectedRow.length < 1) {
        alert("Select A Row");
    }
    else {
        alert(JSON.stringify(selectedRow[0]));
    }
}

// multiple selection
var multRowsSelTable;
function multRowsSelTable() {
    var option = {
        withCheckBox: true,
        disableMutiSel: false,
        tableClass: 'cgridTable',
        head: [
            {
                'data-field': 'id',
                'display': false
            },
            {
                'data-field': 'date',
                'name': 'Date'
            },
            {
                'data-field': 'name',
                'name': 'Name'
            },
            {
                'data-field': 'address',
                'name': 'Address'
            }
        ]
    };
    multRowsSelTable = cgrid.instance("multRowsSelTable", option);
    multRowsSelTable.genTable(results);
}

function multRowsClick() {
    var selectedRows = multRowsSelTable.getChecked();
    if (selectedRows.length < 1) {
        alert("Select A Row");
    }
    else {
        alert(JSON.stringify(selectedRows));
    }
}

var mergeRowResult = [
    { id: '12987122', name: 'jQuery', address: 'Your Address Here', state: 'Alabama', city: 'Birmingham' },
    { id: '12987122', name: 'jQuery', address: 'Your Address Here', state: 'Alabama', city: 'Birmingham' },
    { id: '12987124', name: 'jQuery', address: 'Your Address Here', state: 'Alabama', city: 'Birmingham' },
    { id: '12987124', name: 'jQuery', address: 'Your Address Here', state: 'Alabama', city: 'Birmingham' },
    { id: '12987125', name: 'jQuery', address: 'Your Address Here', state: 'Alabama', city: 'Birmingham' },
];

var mergeColumnResult = [
    { id: '12987122', name: '12987122', address: 'Your Address Here', state: 'Alabama', city: 'Birmingham' },
    { id: '12987123', name: 'jQuery', address: 'Your Address Here', state: 'Alabama', city: 'Birmingham' },
    { id: '12987124', name: '12987124', address: 'Your Address Here', state: 'Alabama', city: 'Birmingham' },
    { id: '12987125', name: 'jQuery', address: 'Your Address Here', state: 'Alabama', city: 'Birmingham' },
];

// merge rows
function mergeRowTable() {
    var option = {
        tableClass: 'cgridTable',
        head: [
            {
                'data-field': 'id',
                'name': 'ID',
                'mergeRow': true,
            },
            {
                'data-field': 'name',
                'name': 'Name'
            },
            {
                'data-field': 'state',
                'name': 'State'
            },
            {
                'data-field': 'city',
                'name': 'City'
            },
            {
                'data-field': 'address',
                'name': 'Address'
            }
        ]
    };
    var ctable = cgrid.instance("mergeRowTable", option);
    ctable.genTable(mergeRowResult);
}

// merge columns
function mergeColumnTable() {
    var option = {
        tableClass: 'cgridTable',
        head: [
            {
                'data-field': 'id',
                'name': 'ID'
            },
            {
                'data-field': 'name',
                'name': 'Name'
            },
            {
                'data-field': 'state',
                'name': 'State'
            },
            {
                'data-field': 'city',
                'name': 'City'
            },
            {
                'data-field': 'address',
                'name': 'Address'
            }
        ],
        mergeinrows: [1,3],
        mergerowcellsize: 2,
    };
    var ctable = cgrid.instance("mergeColumnTable", option);
    ctable.genTable(mergeColumnResult);
}
